/**************************************************************************\
  class BPatches
  ==============

  PointGroup-type class which contains a group of bicubic patches
\**************************************************************************/

#ifndef _BPATCHES_H_
#define _BPATCHES_H_

#include "PointGrp.h"

class BPatches: public PointGroup
{
public:
    BPatches();
    ~BPatches();

    // Inherited methods:
    const std::string& Name();

    // Specific methods

//======================================================================
private:
    // Inherited methods
    bool ReadPovray(InputStream&);
    bool ReadPCM(InputStream&);
    bool WritePovray(std::ostream&);
    bool WritePovray2(std::ostream&);
    bool WritePCM(std::ostream&);

    // Specific methods
    struct Patch
    {
        unsigned type, u_steps, v_steps;
        double flatness;
        PointPtr p[16];
        inline Patch(): type(0), u_steps(3), v_steps(3), flatness(0) {}
    };

    std::vector<Patch> patches;
    void Report();
};

#endif

